#ifndef _LCD_2W_H_
#define _LCD_2W_H_

#include <avr/io.h>

#define LCD_CLEARDISPLAY 0x01
#define LCD_RETURNHOME 0x02
#define LCD_ENTRYMODESET 0x04
#define LCD_DISPLAYCONTROL 0x08
#define LCD_CURSORSHIFT 0x10
#define LCD_FUNCTIONSET 0x20
#define LCD_SETCGRAMADDR 0x40
#define LCD_SETDDRAMADDR 0x80

// flags for display entry mode
#define LCD_ENTRYRIGHT 0x00
#define LCD_ENTRYLEFT 0x02
#define LCD_ENTRYSHIFTINCREMENT 0x01
#define LCD_ENTRYSHIFTDECREMENT 0x00

// flags for display on/off control
#define LCD_DISPLAYON 0x04
#define LCD_DISPLAYOFF 0x00
#define LCD_CURSORON 0x02
#define LCD_CURSOROFF 0x00
#define LCD_BLINKON 0x01
#define LCD_BLINKOFF 0x00

// flags for display/cursor shift
#define LCD_DISPLAYMOVE 0x08
#define LCD_CURSORMOVE 0x00
#define LCD_MOVERIGHT 0x04
#define LCD_MOVELEFT 0x00

// flags for function set
#define LCD_8BITMODE 0x10
#define LCD_4BITMODE 0x00
#define LCD_2LINE 0x08
#define LCD_1LINE 0x00
#define LCD_5x10DOTS 0x04
#define LCD_5x8DOTS 0x00


void LCD_write(uint8_t halfByte, uint8_t mode, uint8_t enable);
void LCDsendNibble(uint8_t halfByte, uint8_t mode);
void LCDsend(uint8_t value, uint8_t mode);
void command(uint8_t value);
void LCDputChar(uint8_t value);
void LCDsendString(char *string);
void LCD_SendHex(int32_t data);
void LCDcreateChar(uint8_t location, uint8_t charmap[]);
void LCDsetBacklight(uint8_t brightness) ;
void LCDnoAutoscroll(void);
void LCDautoscroll(void);
void LCDrightToLeft(void);
void LCDleftToRight(void);
void LCDscrollDisplayRight(void);
void LCDscrollDisplayLeft(void);
void blink();
void noBlink();
void cursor();
void noCursor();
void display();
void noDisplay();
void LCDsetCursor(uint8_t col, uint8_t row);
void home();
void LCDclear();
void LCD_init(uint8_t cols, uint8_t lines, uint8_t dotsize);



#endif