/*
* ADS1232_test.c
*
* Created: 16-Mar-18 8:11:38 AM
* Author : Preda
*/
#define F_CPU 8000000UL
#include <avr/io.h>
#include <stdio.h>
#include <util/delay.h>
#include "i2cmaster.h"
#include "lcd_2w.h"

/*Output ports*/
#define GAIN0		PD7
#define GAIN1		PC0
#define SPEED		PC1
#define PWDWN		PC2
#define SCLK		PC4
#define A0			PD6

/*Input ports*/
#define DOUT		3

#define VREF	2.51f
#define GAIN	1
int32_t data = 0;
uint8_t bitread;
int32_t data_read = 0;
uint8_t ReadyToConvert;
double voltage = 0.0;
char buffer[32];




uint8_t shiftIn(uint8_t bitOrder) {
	uint8_t value = 0;
	uint8_t i;
	bitread = 0;
	for (i = 0; i < 8; ++i) {
		PORTC |=(1<<SCLK);
		_delay_us(1);
		PORTC &=~(1<<SCLK);
		bitread = (PINC & (1<<DOUT));
		if (bitOrder == 1){
			value |= bitread << i;
			}else{
			value |= bitread << (7 - i);
		}

	}
	return value;
}

int main(void)
{
	MCUCR |=(1<<JTD);
	DDRD |=(1<<DDD7)|(1<<DDD6);
	DDRC |=(1<<DDC0)|(1<<DDC1)|(1<<DDC2)|(1<<DDC4);
	PORTD &=~((1<<GAIN0));
	PORTC &=~((1<<GAIN1)|(1<<SPEED)|(1<<DOUT));
	PORTC |=(1<<SCLK)|(1<<PWDWN);
	i2c_init();
	LCD_init(16,2,0);
	LCDsetBacklight(255);
	PORTC &=~(1<<PWDWN);
	_delay_us(26);
	PORTC |=(1<<PWDWN);
	PORTC |=(1<<SPEED);
	//assign our stream to standard I/O streams
	PORTC &=~(1<<SCLK);
	
	/* Replace with your application code */
	while (1)
	{
		
		PORTC &=~(1<<SCLK); /*Trecerea clk-ului in stare logica zero, necesara pentru pornirea conversiei*/

		data = 0;
		ReadyToConvert = (PINC & (1<<DOUT)); /* Interogheaza intrarea */

		if ((ReadyToConvert == 0)) { /*cand este zero incepe citirea datelor, MSB mai intai*/
			
			data = shiftIn(1);
			data = data<<8;
			data |= shiftIn(1);
			data = data<<8;
			data |= shiftIn(1);
			PORTC |=(1<<SCLK);
			_delay_us(1);
			PORTC &=~(1<<SCLK);
			data=data & 0x7FFFFF;
			voltage = (((float) (data * VREF) / ((pow(2, 23) - 1) * GAIN)));
			sprintf(buffer,"Vm = %1.5f V", (voltage));
			LCDsetCursor(0,0);
			LCDsendString(buffer);
			/*Secventa de cod utilizata la preluarea offset-ului (calibrare offset), conform foii de catalog*/
			
					for(uint8_t i = 0;i<26;i++)
					{
						PORTC &=~(1<<SCLK);
						_delay_us(1);
						PORTC |=(1<<SCLK);
					}
					
			/*Finalul secventei de calibrare*/
		}
		_delay_ms(200);
	}
}

